#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <time.h>
#include <sys/fcntl.h>
#include "graphlib.h"

int  h,bpp,hx,hy,interlace,loaded,realbytes,EC,IC;
unsigned char anz;
int Code[4096];
unsigned char Col[4096],Anf[4096];

unsigned char *picbuf=NULL;
struct ggi_coord picsize;

unsigned char *blkbuf=NULL;
struct ggi_coord blksize;
struct ggi_coord blkanz ;
struct ggi_coord scrsize;

const 	struct ggi_coord ballsize={7,7};
	struct ggi_coord ballpos;

struct Ballmove { int dx,dy;
		  int vx,vy;
		  int err;  } ballmove = {1,1,1,7,0};

const 	struct ggi_coord paddlesize={30,6};
	struct ggi_coord paddlepos;

const	struct ggi_color fadecol={128,0,128};

struct Gameparm	{ int speed;
		} gamep;

struct Gameparm	startp = {3};

struct gifhead {char ID[6];short int wide,high;char gidb,backcol;} gih;
struct imghead {short int dx,dy,br,hi;char lidb;} imh;

typedef struct ggi_color dregs[256];

dregs locregs;

int getint(char **str);

int bitsinbuf,numbits,numb2;
unsigned long bitbuf;

int getbits(void)
{ int ret;
  static unsigned char buf[256];
  while(bitsinbuf<numbits)
  { if (realbytes==anz) {read(h,&anz,1);realbytes=0;
                         read(h,buf,anz);}
    bitbuf+=(long)buf[realbytes++]<<bitsinbuf;
    bitsinbuf+=8;}
  bitsinbuf-=numbits;ret=bitbuf&(numb2-1);bitbuf>>=numbits;
  return(ret);
}

void outcode(register int num)
{ register int x;
  unsigned char cols[4096];	/* Bisschen viel,aber egal */
  for(x=0;num!=-1&&x<4096;x++) {cols[x]=Col[num];num=Code[num];}
  while(x--)
  { if (hx<picsize.x) picbuf[picsize.x*hy+hx++]=cols[x];
    if (--loaded==0)
    { hx=0;loaded=imh.br;
      switch(interlace)
      {case 0:hy++;break;
       case 1:hy+=8;if (hy-imh.dy>=imh.hi) {interlace++;hy=imh.dy+4;} break;
       case 2:hy+=8;if (hy-imh.dy>=imh.hi) {interlace++;hy=imh.dy+2;} break;
       case 3:hy+=4;if (hy-imh.dy>=imh.hi) {interlace++;hy=imh.dy+1;} break;
       case 4:hy+=2;if (hy-imh.dy>=imh.hi) {interlace++;hy=imh.dy;} break;
      }
    }
  }
}

void loadimg(int delx,int dely)
{ int bpp2,z,alt;
  register int lastcol,neu;
  read(h,&imh,/*sizeof(imh)*/9);if (imh.lidb&64) interlace=1;else interlace=0;
  bpp2=bpp;hx=0;imh.dx+=delx;hy=(imh.dy+=dely);
  if (imh.lidb&0x80)
  { bpp2=(imh.lidb&7)+1;
    for(z=0;z<(1<<bpp2);z++)
     {read(h,&(locregs[z]),sizeof(locregs[0]));}
  }
  read(h,&bpp2,1); /* Needed for 1Bit Gifs */
  numb2=1<<(numbits=bpp2+1);lastcol=1+(EC=1+(IC=1<<bpp2));
  for(z=0;z<(1<<bpp2);z++) {Col[z]=z;Code[z]=-1;Anf[z]=z;}
  loaded=imh.br;
  red: alt=getbits();if (alt==IC) goto red;else outcode(alt);
  while(1)
  {if (lastcol>=numb2&&numbits<12) {numbits++;numb2<<=1;}
   neu=getbits();
   if (neu==IC){numbits=bpp2+1;numb2=1<<numbits;lastcol=1+(EC=1+(IC=1<<bpp2));goto red;}
   if (neu==EC) return;
   if  (neu< lastcol){outcode(neu);		     Col[lastcol]=Anf[neu];} else
    if (neu==lastcol){outcode(alt);outcode(Anf[alt]);Col[lastcol]=Anf[alt];} else
     {puts("Illegal code !");return;}
   Code[lastcol]=alt;Anf[lastcol]=Anf[alt];alt=neu;lastcol++;
  }
}

int loadgif(char *path,int delx,int dely)
{ int x,z;

  if ((h=open(path,O_RDONLY))==-1) return -1;

  bitsinbuf=anz=realbytes=0;bitbuf=0L;
  locregs[0].r=locregs[0].g=locregs[0].b=0;
  locregs[1].r=locregs[1].g=locregs[1].b=255;
  read(h,&gih,sizeof(gih));

  if (strncmp(gih.ID,"GIF87a",6)) {close(h);return -1;}

  picsize.x=gih.wide;
  picsize.y=gih.high;
  if (picbuf) free(picbuf);
  if ((picbuf=malloc(gih.wide*gih.high))==NULL) 
    ggi_panic("Cannot malloc space for picture");

  ggi_getpalvec(0,256,locregs);
  read(h,&x,1);/* SKIP */
  if (gih.gidb&0x80)
  { x=((gih.gidb&0x70)>>4)+1;bpp=(gih.gidb&7)+1;
    for(z=0;z<(1<<bpp);z++)
     {read(h,&(locregs[z]),sizeof(locregs[0]));}}
  x=0;read(h,&x,1);
  switch(x)
  {case ',':loadimg(delx,dely);break;}
  close(h);
  return 0;
}

void fade2col(struct ggi_color to,int sp)
{ dregs hlp;int x,y;
  for(x=256;x>=0;x--)
  { for(y=0;y<256;y++)
    { hlp[y].r=(((unsigned int)locregs[y].r)*x+((unsigned int)to.r)*(256-x))>>8;
      hlp[y].g=(((unsigned int)locregs[y].g)*x+((unsigned int)to.g)*(256-x))>>8;
      hlp[y].b=(((unsigned int)locregs[y].b)*x+((unsigned int)to.b)*(256-x))>>8;}
    ggi_setpalvec(0,256,hlp);}
}

void fadefrcol(struct ggi_color to,int sp)
{ dregs hlp;int x,y;
  for(x=0;x<=256;x++)
  { for(y=0;y<256;y++)
    { hlp[y].r=(((unsigned int)locregs[y].r)*x+((unsigned int)to.r)*(256-x))>>8;
      hlp[y].g=(((unsigned int)locregs[y].g)*x+((unsigned int)to.g)*(256-x))>>8;
      hlp[y].b=(((unsigned int)locregs[y].b)*x+((unsigned int)to.b)*(256-x))>>8;}
    ggi_setpalvec(0,256,hlp);}
}

void piccopy(int x,int y,int br,int h)
{
  while(h--)
   ggi_puthline(x,y++,br,picbuf+x+y*picsize.x);
}

void blockfrompic(int x,int y)
{ piccopy(x*blksize.x,y*blksize.y,blksize.x,blksize.y); }

void drawblk(int x,int y)
{ int col;
  col=blkbuf[x+y*blkanz.x];
  if (col<=' ') blockfrompic(x,y);
  else
  { ggi_setcolor(col);
    ggi_drawbox(x*blksize.x+1,y*blksize.y+1,blksize.x-2,blksize.y-2);
  }
}

void drawball(void)
{ static struct ggi_coord old={0,0};
  piccopy(old.x,old.y,ballsize.x,ballsize.y);
  old.x=ballpos.x;old.y=ballpos.y;
  ggi_setcolor('a');
  ggi_drawbox(old.x,old.y,ballsize.x,ballsize.y);	/* FIXME ! */
}

void drawpaddle(void)
{ static struct ggi_coord old={0,0};
  piccopy(old.x,old.y,paddlesize.x,paddlesize.y);
  old.x=paddlepos.x;old.y=paddlepos.y;
  ggi_setcolor('b');
  ggi_drawbox(old.x,old.y,paddlesize.x,paddlesize.y);	/* FIXME ! */
}

void fulldisp(void)
{ int x,y;

  fade2col(fadecol,0);

  paddlepos.x=ballpos.x=10;
  paddlepos.y=picsize.y-paddlesize.y-1;
  ballpos.y  =paddlepos.y-ballsize.y;
  drawball();drawpaddle();

  piccopy(0,0,picsize.x,picsize.y);

  for(y=0;y<blkanz.y;y++)
    for(x=0;x<blkanz.x;x++)
      drawblk(x,y);

  fadefrcol(fadecol,0);
}

void paddlectrl(void)
{ const int kbstep=5;
  if (ggi_kbhit())
  { switch(ggi_getch())
    { case ',': if (paddlepos.x>                       kbstep) 
    		{ paddlepos.x-=kbstep;drawpaddle(); }
    		break;
      case '.': if (paddlepos.x<picsize.x-paddlesize.x-kbstep) 
      		{ paddlepos.x+=kbstep;drawpaddle(); }
      		break;
    }
  }
}

void ishit(int x,int y,int direct)
{ unsigned char *blkptr;

  if (x<0||y<0||x>=blkanz.x||y>=blkanz.y) return;
  blkptr=blkbuf+x+y*blkanz.x;

  switch(*blkptr)
  { case '9':if (direct) *blkptr='8';else *blkptr=' ';
             break;
    case '8':if (direct) *blkptr='7';else *blkptr=' ';
             break;
    case '7':if (direct) *blkptr='6';else *blkptr=' ';
             break;
    case '6':if (direct) *blkptr='5';else *blkptr=' ';
             break;
    case '5':if (direct) *blkptr='4';else *blkptr=' ';
             break;
    case '4':if (direct) *blkptr='3';else *blkptr=' ';
             break;
    case '3':if (direct) *blkptr='2';else *blkptr=' ';
             break;
    case '2':if (direct) *blkptr='1';else *blkptr=' ';
             break;
    case 's':*blkptr=' ';if (direct) if (gamep.speed) gamep.speed--;break;
    case 'f':*blkptr=' ';if (direct) gamep.speed++;break;
    case 'b':*blkptr=' ';
    	     { int xx,yy;
    	       for(xx=-1;xx<=1;xx++)
    	        for(yy=-1;yy<=1;yy++)
    	         ishit(x+xx,y+yy,0);
    	     } break;
    default :*blkptr=' ';break;
  }
  drawblk(x,y);
}

void chkhit(int x,int y)
{ unsigned char *blkptr;

  if (x<0||y<0||x>=blkanz.x||y>=blkanz.y) return;

  blkptr=blkbuf+x+y*blkanz.x;
  if (*blkptr<=' ') return;

       if (x*blksize.x+1==ballpos.x+ballsize.x) {ballmove.dx=-ballmove.dx;ballpos.x+=ballmove.dx;}
  else if ((x+1)*blksize.x-1==ballpos.x)        {ballmove.dx=-ballmove.dx;ballpos.x+=ballmove.dx;}
  else if (y*blksize.y+1==ballpos.y+ballsize.y) {ballmove.dy=-ballmove.dy;ballpos.y+=ballmove.dy;}
  else if ((y+1)*blksize.y-1==ballpos.y)        {ballmove.dy=-ballmove.dy;ballpos.y+=ballmove.dy;}
  else return;
  
  ishit(x,y,1);
}

void ballctrl(void)
{ int xx,yy;
  if (ballmove.err>0) 
    { ballmove.err-=ballmove.vx;
      ballpos.y+=ballmove.dy;
      if (ballpos.y==0||ballpos.y+ballsize.y==picsize.y) ballmove.dy=-ballmove.dy;
      drawball(); }
  else
    { ballmove.err+=ballmove.vy;
      ballpos.x+=ballmove.dx;
      if (ballpos.x==0||ballpos.x+ballsize.x==picsize.x) ballmove.dx=-ballmove.dx;
      drawball(); }

  if (ballpos.y+ballsize.y>=paddlepos.y)	/* Hit the paddle */
  { xx=ballpos.x-paddlepos.x;
    if (xx>=-ballsize.x&&xx<=paddlesize.x) 
    { ballmove.dy=-1;
      if (xx<0) 
         if (ballmove.dx<0) ballmove.vx++;
         else if (!--ballmove.vx) 
         	{ ballmove.dx=-1;ballmove.vx=1; }

      xx-=paddlesize.x-ballsize.x;
      if (xx>0) 
         if (ballmove.dx>0) ballmove.vx++;
         else if (!--ballmove.vx)
         	{ ballmove.dx= 1;ballmove.vx=1; }
    }
  }

  xx=ballpos.x/blksize.x;
  yy=ballpos.y/blksize.y;
  chkhit(xx,yy);
  xx=(ballpos.x+ballsize.x)/blksize.x;
  chkhit(xx,yy);
  yy=(ballpos.y+ballsize.y)/blksize.y;
  chkhit(xx,yy);
  xx=ballpos.x/blksize.x;
  chkhit(xx,yy);
}

void do_game(void)
{ int y,spdcnt;

  spdcnt=gamep.speed;

  for(y=0;y<40000;y++)
  { paddlectrl();
    ballctrl();
    if (!spdcnt--) {usleep(1);spdcnt=gamep.speed;}
  }

}

int main(int argc,char *argv[])
{ int y;

  FILE *script;
  char filename[1024];

  if (argc!=2||(script=fopen(argv[1],"r"))==NULL) 
     { fprintf(stderr,"Usage: bout script\n");exit(1); }

  ggi_init();

  while(!feof(script))
  { 
    if (1!=fscanf(script,"%s",filename)) break;
    if (loadgif(filename,0,0)) ggi_panic("GIF not found.");

    if (2!=fscanf(script,"%d %d",&scrsize.x,&scrsize.y)) ggi_panic("No screen-size given.");
    ggi_graphmode(scrsize.x,scrsize.y,picsize.x,picsize.y,GT_8BIT);

    if (2!=fscanf(script,"%d %d",&blkanz.x,&blkanz.y)) ggi_panic("No block-array-size given.");
    blksize.x=picsize.x/blkanz.x;
    blksize.y=picsize.y/blkanz.y;
    if (blksize.x<3||blksize.y<3) ggi_panic("Blocks too small.");

    if (blkbuf) free(blkbuf);
    if ((blkbuf=malloc(blkanz.x*blkanz.y+1))==NULL) ggi_panic("Cannot malloc block buffer.");
    memset(blkbuf,' ',blkanz.x*blkanz.y);

    for(y=0;y<blkanz.y;y++)
      if (fscanf(script,"\n*%[^\n]",blkbuf+blkanz.x*y)!=1) break;

    fulldisp();

    gamep=startp;

    do_game();
    ggi_getch();
  }
  ggi_exit();
  return(0);
}
