#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include "graphlib.h"

struct ggi_color aktregs[256];

int dimensions;

struct Line { int start,stop; };

struct object { int dots,lines;
		double *punkt;
		struct Line *line; } obj;

int 	m[4];
struct pbuf {int x1,y,x2;};
struct pbuf *punktbuf[2];
char name[81];
typedef double mat[4][4];
mat source,matrix,hlp,hlp2;
double sphi,cphi;
int xb,yb,tx,ty;
double ddy=-2000.0;
double eye=-100.0;
int del=20;
int color1=1;
int color2=2;
int as=0;
int filmh=-1;
FILE *in,*out;

void inputobject(void)
{ int x,y;double *help;
  struct Line *h;
  puts("  D i m e n s i o n - X    (c) by H. & A. Beck Individualsoftware 25/02/1991\r\n");
  puts("\r\n");
  out=fopen("/dev/null","w");
  if (in==stdin) {puts("Objekt speichern      ?");
		  if (ggi_getch()=='j')
		      {fclose(out);out=fopen("objekt.dat","w");puts("Ja.");}
		  else puts("Nein.");}
  puts("\r\nFilm auf Disk erzeugen?");if (ggi_getch()=='j'&&(filmh=open("film.dix",O_WRONLY|O_CREAT|O_TRUNC,0644))!=-1)
					  puts("Ja.");else puts("Nein.");
  puts("\r\nName   des Objekts    :");fscanf(in,"%s",name);fprintf(out,"%s\n",name);
  puts("Anzahl der Dimensionen:");fscanf(in,"%d",&dimensions);fprintf(out,"%d\n",dimensions);
  puts("Anzahl der Punkte     :");fscanf(in,"%d",&obj.dots);fprintf(out,"%d\n",obj.dots);
  puts("Anzahl der Linien     :");fscanf(in,"%d",&obj.lines);fprintf(out,"%d\n",obj.lines);
  if (filmh!=-1) write(filmh,&obj.lines,2);
  puts("Punkteingabe:\r\n");
  if ((obj.punkt=malloc(dimensions*obj.dots*sizeof(double)))==0) exit(0);
  if ((obj.line=malloc(obj.lines*sizeof(struct Line)))==0) exit(0);
  if ((punktbuf[0]=malloc(obj.lines*sizeof(struct pbuf)))==0) exit(0);
  memset(punktbuf[0],0,obj.lines*sizeof(struct pbuf));
  if ((punktbuf[1]=malloc(obj.lines*sizeof(struct pbuf)))==0) exit(0);
  memset(punktbuf[1],0,obj.lines*sizeof(struct pbuf));
  help=obj.punkt;h=obj.line;
  for(x=0;x<obj.dots;x++)
  { printf("Punkt Nr.:%d\r\n",x);
    for(y=0;y<dimensions;y++)
    {printf("A%d:",y);fscanf(in,"%lf",help);fprintf(out,"%f\n",*help);help++;}}
  for(x=0;x<obj.lines;x++)
  { printf("Linie Nr.%d Anf:",x+1);
    fscanf(in,"%d",&h->start);fprintf(out,"%d\n",h->start);
    printf("Linie Nr.%d End:",x+1);
    fscanf(in,"%d",&h->stop );fprintf(out,"%d\n",h->stop );
    h++;}
  fclose(out);
}

void transform2(void/*int dim1,int dim2*/)
{ int count;
  double hilfe,*h,se,ed,x,y,z,w;
  struct pbuf *p;
  for(count=0,h=obj.punkt,p=punktbuf[as];count<obj.dots;count++,h+=dimensions,p++)
  {x=*h;y=*(h+1);z=*(h+2);w=*(h+3);
   hilfe=x*matrix[2][0]+y*matrix[2][1]+z*matrix[2][2]+w*matrix[2][3];
   se=ddy/(hilfe+m[2]-ddy);ed=se*eye+eye;
   hilfe=x*matrix[0][0]+y*matrix[0][1]+z*matrix[0][2]+w*matrix[0][3];
   p->x2=(p->x1=xb+ed+(m[0]-hilfe)*se)-ed-ed;
   hilfe=x*matrix[1][0]+y*matrix[1][1]+z*matrix[1][2]+w*matrix[1][3];
   p->y=yb+(m[1]+hilfe)*se;}
}

void matrimult(void)
{ int x,y,z;memcpy(source,matrix,sizeof(matrix));
  for(x=0;x<4;x++)
   for(y=0;y<4;y++)
   {matrix[x][y]=0.0;for(z=0;z<4;z++) matrix[x][y]+=source[x][z]*hlp[z][y];}}

void matrimult2(void)
{ int x,y,z;memcpy(source,hlp,sizeof(hlp));
  for(x=0;x<4;x++)
   for(y=0;y<4;y++)
   {hlp[x][y]=0.0;for(z=0;z<4;z++) hlp[x][y]+=source[x][z]*hlp2[z][y];}}

void draw(void)
{int count,ed;
 double *h,se;
 struct pbuf *p,*p2;
 struct Line *lb;
 /*setdrawmode(NORMAL);*/
 as^=1;yb=as*CurrentMode.visible.y+CurrentMode.visible.y/2;
 for(count=0,lb=obj.line;count<obj.lines;count++,lb++)
  { p=(punktbuf[as]+lb->start);p2=(punktbuf[as]+lb->stop);
    ggi_setcolor(0);
    ggi_drawline( p->x1,p->y,p2->x1,p2->y);
    ggi_drawline( p->x2,p->y,p2->x2,p2->y);}
 matrimult();transform2();

 /*setdrawmode(OR);*/

 if (filmh!=-1) write(filmh,punktbuf[as],obj.dots*sizeof(struct pbuf));

 for(count=0,lb=obj.line;count<obj.lines;count++,lb++)
  {p=(punktbuf[as]+lb->start);p2=(punktbuf[as]+lb->stop);
   ggi_setcolor(color1);
   ggi_drawline( p->x1,p->y,p2->x1,p2->y);
   ggi_setcolor(color2);
   ggi_drawline( p->x2,p->y,p2->x2,p2->y);}


   ggi_setviswin(0,as*CurrentMode.visible.y);
   usleep(1);
#if 0
   while((inportb(0x03da)&8)==0);
   while( inportb(0x03da)&8);outport(0x03d4,0x0c+as*125*256);
   while((inportb(0x03da)&8)==0);
#endif

}

void killhlp(void)
{ int x,y;
  for(x=0;x<4;x++)
   for(y=0;y<4;y++)
   {hlp2[x][y]= (x==y&&x<dimensions) ? 1 : 0;}}

void waitbuttchg(int x)
{ 
#if 0
do {rp.r_ax=3;intr(0x33,&rp);}while((rp.r_bx&7)==(x&7));
#endif
}

void main(int argn,char *argv[])
{ int x,y,h1,h2;
  sphi=sin(M_PI/1600);cphi=cos(M_PI/1600);
  m[0]=m[1]=m[3]=m[2]=0;
  ggi_init();
  in=stdin;
  if (argn>=2)
  { if ((in=fopen(argv[1],"r"))==0)
    { puts("Unable to open file !");exit(1); }
  }
#if 0
  if (argn==2) ungetch('n');
#endif

  inputobject();
  if (in!=stdin) fclose(in);
  ggi_graphmode(800,600,800,1200,GT_8BIT);
  ggi_setcolor(3);
  xb=CurrentMode.visible.x/2;
  yb=CurrentMode.visible.y/2;
  for(x=0;x<4;x++)
   for(y=0;y<4;y++)
   { source[x][y]=matrix[x][y]=hlp[x][y]=hlp2[x][y]= (x==y&&x<dimensions) ? 1 : 0;}

  ggi_printf(0,000,"%s",name);
  ggi_printf(0,600,"%s",name);

  ggi_getpalvec(0,256,aktregs);

  aktregs[0].r=  0;aktregs[0].g=  0;aktregs[0].b= 0;
  aktregs[1].r=184;aktregs[1].g=  0;aktregs[1].b= 0;
  aktregs[2].r= 00;aktregs[2].g=144;aktregs[2].b= 0;
  aktregs[3].r=184;aktregs[3].g=144;aktregs[3].b= 0;

  ggi_setpalvec(0,256,aktregs);

  draw();tx=0;ty=1;x=-1;

#if 0
  gotoxy(1,1);puts("                              ");
  rp.r_ax=0;intr(0x33,&rp);rp.r_ax=2;intr(0x33,&rp);
  rp.r_ax=7;rp.r_cx=0000;rp.r_dx=16000;intr(0x33,&rp);
  rp.r_ax=8;rp.r_cx=0000;rp.r_dx=16000;intr(0x33,&rp);
  rp.r_ax=4;rp.r_cx=8000;rp.r_dx= 8000;intr(0x33,&rp);
  rp.r_ax=0xf;rp.r_cx= 1;rp.r_dx=    1;intr(0x33,&rp);
#endif
  do
  {recen:if (ggi_kbhit()) {x=ggi_getch();}
#if 0
   rp.r_ax=3;intr(0x33,&rp);
   if ((rp.r_bx&7)==7||x==27) break;
   if (rp.r_bx&4) x='t';
   if (rp.r_bx&2) x='T';
   if ((rp.r_bx&6)==6) x='0';
   if ((rp.r_bx&1)&&as==0)
		  {do{rp.r_ax=3;intr(0x33,&rp);
		      if (rp.r_bx&4) {tx++;tx%=dimensions;}
		      if (rp.r_bx&2) {ty++;ty%=dimensions;}
		      gotoxy(1,1);printf("%d - %d",tx,ty);waitbuttchg(rp.r_bx);
		     }while(rp.r_bx&1);
		     rp.r_ax=4;rp.r_cx=-8*m[tx]+8000;rp.r_dx=-8*m[ty]+8000;
		     gotoxy(1,1);puts("                              ");
		     intr(0x33,&rp);goto recen;}
   m[tx]+=1000-(rp.r_cx>>3);m[tx]/=2;
   m[ty]+=1000-(rp.r_dx>>3);m[ty]/=2;
#endif
   draw();if(x==-1) goto recen;
   switch(x)
   {case 'a':tx=(abs(ggi_getch()-48))%dimensions;ty=(abs(ggi_getch()-48))%dimensions;break;
    case 't':killhlp(); hlp2[tx][tx]= cphi;hlp2[ty][tx]= sphi;
			hlp2[tx][ty]=-sphi;hlp2[ty][ty]= cphi;
	     matrimult2();break;
    case 'T':killhlp(); hlp2[tx][tx]= cphi;hlp2[ty][tx]=-sphi;
			hlp2[tx][ty]= sphi;hlp2[ty][ty]= cphi;
	     matrimult2();break;
    case 'm':m[tx]+=10;break;
    case 'M':m[tx]-=10;break;
    case '0':for(x=0;x<4;x++) for(y=0;y<4;y++)
		{hlp[x][y]= (x==y&&x<dimensions) ? 1 : 0;} break;
    case '=':for(x=0;x<4;x++) for(y=0;y<4;y++)
		{matrix[x][y]= (x==y&&x<dimensions) ? 1 : 0;} break;
    case 'x':case 'g':killhlp();for (x=0;x<4;x++) hlp2[x][x]=1.02;matrimult2();break;
    case 'y':case 'k':killhlp();for (x=0;x<4;x++) hlp2[x][x]=1/1.02;matrimult2();break;
   }
  x=-1;
  }while(x!=27);

  ggi_exit();
  if (filmh!=-1) close(filmh);
}
