#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/fcntl.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <linux/vt.h>
#include <string.h>
#include "graphlib.h"

struct ggi_color pal[256];

int main(void)
{ int t,x,c,y;
  int sx[]={800,640,640,640,640,640,320,320,320,160};
  int sy[]={600,480,400,200,100, 50,240,200,100,120};

  ggi_init();
         
  for(t=0;t<sizeof(sx)/sizeof(int);t++)
  {
   if (ggi_graphmode(sx[t],sy[t],sx[t],sy[t],GT_8BIT)) continue;

    ggi_setcolor(0);
    ggi_fillscreen();

    for(x=0;x<8;x++)
    { ggi_setpage(x);
      for(y=0;y<64*1024;y++)
       *(ggi_pagedbuffer+y)=x+1;
      ggi_getch();
    }
  }
  ggi_exit();
  return(0);
}
