/* 
   S3 964 Chipset-Driver header file

   Copyright (C) 1995 Andreas Beck - becka@hp.rz.uni-duesseldorf.de

   If you do any modifications, I would like you to send diffs to me
   to allow for collecting a more and more complete set of drivers and
   to improve existing ones.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

static void unlock_s3(void);
static void lock_s3(void);
static int Detect_Vision964(void);
static void ResetCard(void);
static void SetExtendedTiming(struct kgi_mode *TM,int xvirtshift);
static int CheckAccelmode(struct kgi_mode *TM,int olderr);
static int SetAccelmode(struct kgi_mode *TM,int xvirtshift);
static int CheckText(struct kgi_mode *TM,int command);
static int SetText(struct kgi_mode *TM);
static int Check4bit(struct kgi_mode *TM,int olderr);
static int Set4bit(struct kgi_mode *TM);
static int Check8bit(struct kgi_mode *TM,int olderr);
static int Set8bit(struct kgi_mode *TM);
static int Check16bit(struct kgi_mode *TM,int olderr);
static int Set16bit(struct kgi_mode *TM);
static int Check32bit(struct kgi_mode *TM,int olderr);
static int Set32bit(struct kgi_mode *TM);
int kgi_CheckChipsetTiming(struct kgi_mode *TM,int olderr);
int kgi_SetChipsetTiming(struct kgi_mode *TM);
void hw_setdispstart(int dx,int dy);
static int s3_wait_fifo(int spc_need);
static int s3_wait_idle(void);
int setinforec(void);
static int s3_drawbox(void);
static int s3_drawline(void);
int kgi_ChipsetIoctl(struct inode *inode, struct file *file, \
        unsigned int cmd, unsigned long arg);
void kgi_GraphmapClose(struct vm_area_struct * area);
unsigned long kgi_GraphmapNopage(struct vm_area_struct * area, unsigned long address,
	unsigned long page, int no_share);
int kgi_ChipsetInit(void);
void kgi_ChipsetCleanup(void);
