/* 

   Copyright (C) 1995 Andreas Beck - becka@hp.rz.uni-duesseldorf.de
   
   These are the declarations for functions that the generic routines
   need.These must be defined by the hardware layer.

   If you do any modifications, I would like you to send diffs to me
   to allow for collecting a more and more complete set of drivers and
   to improve existing ones.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

void hw_setdispstart(int dx,int dy);	/* This has to set the display start-address */
int  hw_setpal(int start,int anz,struct ggi_color *buf);
void kgi_linearmap_close(struct vm_area_struct * area);
unsigned long kgi_linearmap_nopage(struct vm_area_struct * area, unsigned long address,
        unsigned long page, int no_share);
void kgi_pagedmap_close(struct vm_area_struct * area);
unsigned long kgi_pagedmap_nopage(struct vm_area_struct * area, unsigned long address,
        unsigned long page, int no_share);
void hw_getpal(int start,int anz,struct ggi_color *buffer);
